const express = require("express");
const connection = require("./connection.js");
const app = express();
const bodyParser = require("body-parser");
var request = require("request");
const cors = require("cors");
const db_con = require("./connection");
// require('dotenv').config();

app.use(bodyParser.json());
// app.use(bodyParser.json({ limit: '50mb' }));
app.use(
  bodyParser.urlencoded({
    limit: "50mb",
    extended: true,
    parameterLimit: 500000,
  })
);
// cors doc
app.use("/uploads", express.static("uploads"));
app.use(cors({ origin: true, credentials: true }));
app.use(function (req, res, next) {
  res.header("Access-Control-Allow-Origin", req.headers.origin);
  res.setHeader(
    "Access-Control-Allow-Methods",
    "GET, POST, OPTIONS, PUT, PATCH, DELETE"
  );
  res.setHeader(
    "Access-Control-Allow-Headers",
    "X-Requested-With, Origin, Content-Type, Accept"
  );
  res.setHeader("Access-Control-Allow-Credentials", true);
  next();
});

app.set("view engine", "ejs");
//import routs
const tour = require("./controller/app-tour-controller");
const vendor = require("./controller/vendor-controller");
const imageUploader = require("./controller/image-controller");
const postControler = require("./controller/post-controller");
const booking = require("./controller/app-booking-controller");
const pages = require("./controller/app-page-controller");
const navigation = require("./controller/navigation-controller");
const user = require("./controller/web-user-controller");

//app middleware

app.use("/tour", tour);
app.use("/vendor", vendor);
app.use("/imageUploader", imageUploader);
app.use("/post", postControler);
app.use("/bookings", booking);
app.use("/pages", pages);
app.use("/navigation", navigation);
app.use("/user", user);

var cron = require("node-cron");

cron.schedule(
  "0 0 11 2-31/2 * *",
  () => {
    app.get("/", (req, res) => {
      res.send("Hellow world");
      console.log("Hello world");
      request(
        "https://api.rezdy-staging.com/v1/products/marketplace?apiKey=69f708868ddc45eaa1f9b9fad1ddeba5",
        function (error, response, body) {
          if (!error && response.statusCode === 200) {
            console.log(body); // Print the google web page.
          }
        }
      );
    });
    console.log("Running a job at 01:00 at America/Sao_Paulo timezone");
  },
  {
    scheduled: true,
    timezone: "America/Sao_Paulo",
  }
);

const TourCMSApi = require("tourcms");

const TourCMS = new TourCMSApi({
  channelId: 3930,
  apiKey: "3427fc4f7d22",
  marketplaceId: 55096,
});

//List all Tours on Channel 3930
// TourCMS.showTour({
//   tourId: 1,
//   callback: function (response) {
//     console.log(response);
//   },
// });

// TourCMS.searchTours({
//   channelId: 3930,
//   callback: function (response) {
//     let tableHeader = [];
//     tableHeader.push(`tour_id`, `tour_data`);
//     let query = "INSERT INTO tour_cms (" + tableHeader + ") VALUES ?";
//     let values = response.tour.reduce((o, a) => {
//       let ini = [];
//       ini.push(a.tour_id);
//       ini.push(JSON.stringify(a));
//       o.push(ini);
//       return o;
//     }, []);
//     db_con.query(query, [values], (error, results, fields) => {
//       if (error) {
//         console.log(error);
//         res.send({
//           code: 400,
//           failed: "error request",
//         });
//       } else {
//         console.log("Tour CMS Added Successfully");
//         res.send({
//           code: 200,
//           message: "Tour CMS Added Successfully",
//         });
//       }
//     });

//     console.log(response);
//   },
// });

// routes

// server port
app.listen(3000);
