const express = require("express");
const router = express.Router();
const multer = require("multer");
const db_con = require("../connection");
const TourCMSApi = require("tourcms");

const TourCMS = new TourCMSApi({
  channelId: 3930,
  apiKey: "3427fc4f7d22",
  marketplaceId: 55096,
});

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "uploads/");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + file.originalname);
  },
});

let upload = multer({
  storage: storage,
});

router.get("/", (req, res, next) => {
  res.send("Hellow world");
  console.log("Tour Added");
});

router.post("/setSingleTour", (req, res) => {
  const tourBody = req.body.tourObject;
  let container = [];
  let tableHeader = [];
  container.push(tourBody);
  tableHeader.push(
    `tour_id`,
    `agent_id`,
    `user_type`,
    `tour_agent_name`,
    `agent_color`,
    `tour_status`,
    `tour_title`,
    `tour_desc`,
    `tour_content`,
    `tour_tips`,
    `tour_category`,
    `tour_video`,
    `tour_duration`,
    `tour_min_people`,
    `tour_max_people`,
    `tour_start_date`,
    `tour_end_date`,
    `tour_create_date`,
    `tour_faq`,
    `tour_include`,
    `tour_exclude`,
    `tour_itinerary`,
    `tour_gallery`,
    `tour_banner_image`,
    `tour_location`,
    `tour_address`,
    `tour_map_zoom`,
    `tour_price`,
    `tour_sale_price`,
    `tour_persion_status`,
    `tour_persion_type`,
    `tour_hotel_status`,
    `tour_hotel`,
    `tour_discount_by_people`,
    `tour_attributes_category`,
    `tour_attributes_facilities`,
    `tour_attributes_lunch`,
    `tour_maps`,
    `feature_tour`
  );
  // let tableHeader = req.body.tableHeader.join(',')
  let query = "INSERT INTO all_tour (" + tableHeader + ") VALUES ?";
  let values = container.reduce((o, a) => {
    let ini = [];
    ini.push(a.tour_id);
    ini.push(a.agent_id);
    ini.push(a.user_type);
    ini.push(a.tour_agent_name);
    ini.push(a.agent_color);
    ini.push(a.tour_status);
    ini.push(a.tour_title);
    ini.push(a.tour_desc);
    ini.push(a.tour_content);
    ini.push(a.tour_tips);
    ini.push(a.tour_category);
    ini.push(a.tour_video);
    ini.push(a.tour_duration);
    ini.push(a.tour_min_people);
    ini.push(a.tour_max_people);
    ini.push(a.tour_start_date);
    ini.push(a.tour_end_date);
    ini.push(a.tour_create_date);
    ini.push(a.tour_faq);
    ini.push(a.tour_include);
    ini.push(a.tour_exclude);
    ini.push(a.tour_itinerary);
    ini.push(a.tour_gallery);
    ini.push(a.tour_banner_image);
    ini.push(a.tour_location);
    ini.push(a.tour_address);
    ini.push(a.tour_map_zoom);
    ini.push(a.tour_price);
    ini.push(a.tour_sale_price);
    ini.push(a.tour_persion_status);
    ini.push(a.tour_persion_type);
    ini.push(a.tour_hotel_status);
    ini.push(a.tour_hotel);
    ini.push(a.tour_discount_by_people);
    ini.push(a.tour_attributes_category);
    ini.push(a.tour_attributes_facilities);
    ini.push(a.tour_attributes_lunch);
    ini.push(a.tour_maps);
    ini.push(a.feature_tour);
    o.push(ini);
    return o;
  }, []);

  db_con.query(query, [values], (error, results, fields) => {
    if (error) {
      console.log(error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Tour Added Successfully",
      });
    }
  });
});

router.post("/editSingleTour", (req, res) => {
  const tourBody = req.body.tourObject;
  let container = [];
  let tableHeader = [];
  container.push(tourBody);

  let query = `DELETE FROM all_tour WHERE tour_id = ?`;

  // console.log(tourBody.tour_id)
  db_con.query(query, [tourBody.tour_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      tableHeader.push(
        `tour_id`,
        `agent_id`,
        `user_type`,
        `tour_agent_name`,
        `agent_color`,
        `tour_status`,
        `tour_title`,
        `tour_desc`,
        `tour_content`,
        `tour_tips`,
        `tour_category`,
        `tour_video`,
        `tour_duration`,
        `tour_min_people`,
        `tour_max_people`,
        `tour_start_date`,
        `tour_end_date`,
        `tour_create_date`,
        `tour_faq`,
        `tour_include`,
        `tour_exclude`,
        `tour_itinerary`,
        `tour_gallery`,
        `tour_banner_image`,
        `tour_location`,
        `tour_address`,
        `tour_map_zoom`,
        `tour_price`,
        `tour_sale_price`,
        `tour_persion_status`,
        `tour_persion_type`,
        `tour_hotel_status`,
        `tour_hotel`,
        `tour_discount_by_people`,
        `tour_attributes_category`,
        `tour_attributes_facilities`,
        `tour_attributes_lunch`,
        `tour_maps`,
        `feature_tour`
      );
      // let tableHeader = req.body.tableHeader.join(',')
      let query = "INSERT INTO all_tour (" + tableHeader + ") VALUES ?";
      let values = container.reduce((o, a) => {
        let ini = [];
        ini.push(a.tour_id);
        ini.push(a.agent_id);
        ini.push(a.user_type);
        ini.push(a.tour_agent_name);
        ini.push(a.agent_color);
        ini.push(a.tour_status);
        ini.push(a.tour_title);
        ini.push(a.tour_desc);
        ini.push(a.tour_content);
        ini.push(a.tour_tips);
        ini.push(a.tour_category);
        ini.push(a.tour_video);
        ini.push(a.tour_duration);
        ini.push(a.tour_min_people);
        ini.push(a.tour_max_people);
        ini.push(a.tour_start_date);
        ini.push(a.tour_end_date);
        ini.push(a.tour_create_date);
        ini.push(a.tour_faq);
        ini.push(a.tour_include);
        ini.push(a.tour_exclude);
        ini.push(a.tour_itinerary);
        ini.push(a.tour_gallery);
        ini.push(a.tour_banner_image);
        ini.push(a.tour_location);
        ini.push(a.tour_address);
        ini.push(a.tour_map_zoom);
        ini.push(a.tour_price);
        ini.push(a.tour_sale_price);
        ini.push(a.tour_persion_status);
        ini.push(a.tour_persion_type);
        ini.push(a.tour_hotel_status);
        ini.push(a.tour_hotel);
        ini.push(a.tour_discount_by_people);
        ini.push(a.tour_attributes_category);
        ini.push(a.tour_attributes_facilities);
        ini.push(a.tour_attributes_lunch);
        ini.push(a.tour_maps);
        ini.push(a.feature_tour);
        o.push(ini);
        return o;
      }, []);

      db_con.query(query, [values], (error, results, fields) => {
        if (error) {
          console.log(error);
          res.send({
            code: 400,
            failed: "error request",
          });
        } else {
          res.send({
            code: 200,
            message: "Tour Edited Successfully",
          });
        }
      });
    }
  });
});

router.post("/updateReviewsDetails", (req, res) => {
  let query = `UPDATE all_tour SET tour_persion_type = ? WHERE tour_id = ?; `;
  const reviewBody = req.body;
  db_con.query(
    query,
    [reviewBody.tour_review_data, reviewBody.tour_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

// update tour slider
router.post("/updateFeatureTour", (req, res) => {
  let query = `UPDATE all_tour SET feature_tour = ? WHERE tour_id = ?; `;
  const reviewBody = req.body;
  db_con.query(
    query,
    [reviewBody.feature_tour, reviewBody.tour_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/setLocation", (req, res) => {
  const locationBody = req.body;
  let query =
    "INSERT INTO tour_location (`location_id`,`cityname`,`city_place`,`created_date`,`location_image`) VALUES (?,?,?,?,?)";

  db_con.query(
    query,
    [
      locationBody.location_id,
      locationBody.cityname,
      locationBody.city_place,
      locationBody.created_date,
      locationBody.location_image,
    ],
    (error, results, fields) => {
      if (error) {
        console.log(error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        console.log("Category Added Successfully");
        res.send({
          code: 200,
          message: "Category Added Successfully",
        });
      }
    }
  );
});

router.post("/updateLocation", (req, res) => {
  const body = req.body;
  let query = `UPDATE tour_location SET ? WHERE location_id= ?`;
  db_con.query(
    query,
    [req.body, req.body.location_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/setCategory", (req, res) => {
  const categoryBody = req.body;
  let query =
    "INSERT INTO all_tour_category (`category_name`,`created_date`,`category_id`,`category_icon_image`) VALUES (?,?,?,?)";

  db_con.query(
    query,
    [
      categoryBody.category_name,
      categoryBody.created_date,
      categoryBody.category_id,
      categoryBody.category_icon_image,
    ],
    (error, results, fields) => {
      if (error) {
        console.log(error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        console.log("Category Added Successfully");
        res.send({
          code: 200,
          message: "Category Added Successfully",
        });
      }
    }
  );
});

router.post("/updateCategory", (req, res) => {
  const body = req.body;
  let query = `UPDATE all_tour_category SET ? WHERE category_id= ?`;
  db_con.query(
    query,
    [req.body, req.body.category_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/setTourAttributes", (req, res) => {
  const attributesBody = req.body;
  let query =
    "INSERT INTO all_tour_attributes (`attributes_parant_name`,`attributes_name`,`attributes_date`,`attributes_id`) VALUES (?,?,?,?)";

  db_con.query(
    query,
    [
      attributesBody.attributes_parant_name,
      attributesBody.attributes_name,
      attributesBody.attributes_date,
      attributesBody.attributes_id,
    ],
    (error, results, fields) => {
      if (error) {
        console.log(error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        console.log("Attributes Added Successfully");
        res.send({
          code: 200,
          message: "Attributes Added Successfully",
        });
      }
    }
  );
});

router.post("/updateTourAttributes", (req, res) => {
  const body = req.body;
  let query = `UPDATE all_tour_attributes SET ? WHERE attributes_id= ?`;

  console.log(body);
  db_con.query(
    query,
    [req.body, req.body.attributes_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/singleTourDetails", (req, res) => {
  const body = req.body;

  query = "SELECT * FROM all_tour WHERE tour_id=?";
  db_con.query(query, [body.tour_id], function (error, results, fields) {
    if (error) {
      console.log(error);
      res.send({
        code: 402,
        failed: "error request",
      });
    } else {
      if (results.length != 0) {
        res.send({
          code: 200,
          message: "Single Tour Details",
          Payload: results,
        });
      } else {
        res.send({
          code: 404,
          message: "No Data Found",
        });
      }
    }
  });
});

const id = (length) => {
  let mask = "";
  mask += "0123456789";
  let result = "";
  for (var i = length; i > 0; --i)
    result += mask[Math.round(Math.random() * (mask.length - 1))];
  return result;
};

// get api

router.get("/getTourForVendor", (req, res) => {
  const vendortype = req.query.vendortype;
  const vendorId = req.query.vendorId;
  if (vendortype == "Admin") {
    query = "SELECT * FROM all_tour ORDER BY tour_create_date DESC";

    db_con.query(query, function (error, results, fields) {
      if (error) {
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Success",
          Payload: results,
        });
      }
    });
  } else {
    query =
      "SELECT * FROM all_tour WHERE user_type=? AND agent_id=? ORDER BY tour_create_date DESC";
    db_con.query(
      query,
      [vendortype, vendorId],
      function (error, results, fields) {
        if (error) {
          console.log(error);
          res.send({
            code: 402,
            failed: "error request",
          });
        } else {
          if (results.length != 0) {
            res.send({
              code: 200,
              message: "Login Successful",
              Payload: results,
            });
          } else {
            res.send({
              code: 402,
              message: "No Data Found",
            });
          }
        }
      }
    );
  }
});

router.get("/getAllTour", (req, res) => {
  query = "SELECT * FROM all_tour ORDER BY tour_create_date DESC";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});
router.get("/getResentTour", (req, res) => {
  query = "select * from all_tour ORDER BY created_date DESC limit 10";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

router.get("/getAllCategory", (req, res) => {
  query = "SELECT * FROM all_tour_category ORDER BY created_date DESC";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

router.get("/getAllCategoryForHome", (req, res) => {
  query = "SELECT * FROM all_tour_category ORDER BY created_date DESC limit 6";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

// get all location
router.get("/getAllLocation", (req, res) => {
  query = "SELECT * FROM tour_location ORDER BY created_date DESC";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

// location for home
router.get("/getAllLocationForHome", (req, res) => {
  query = "SELECT * FROM tour_location";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

router.get("/getAllAttributes", (req, res) => {
  query = "SELECT * FROM all_tour_attributes ";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

// delete api

router.post("/deleteTour", (req, res) => {
  const body = req.body;
  let query = `DELETE FROM all_tour WHERE tour_id = ?`;
  db_con.query(query, [body.tour_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});
router.post("/deleteLocation", (req, res) => {
  const body = req.body;
  let query = `DELETE FROM tour_location WHERE location_id = ?`;
  db_con.query(query, [body.location_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});

router.post("/deleteCategory", (req, res) => {
  // const body = req.body
  // // let query = `DELETE FROM all_tour_category WHERE category_id = ?`;
  // category_id_container = []
  // console.log(req.body)
  // req.body.forEach(element => {
  //     category_id_container.push(element.category_id)
  // });
  // let allids = category_id_container.join(',')
  // let query = `DELETE FROM all_tour_category WHERE category_id IN (` + allids + `);`;
  // db_con.query(query, (error, results, fields) => {
  //     if (error) {
  //         console.log("error ocurred", error);
  //         res.send({
  //             "code": 400,
  //             "failed": "error request"
  //         })
  //     } else {
  //         console.log('Resultats: ', results);
  //         res.send({
  //             "code": 200,
  //             "message": "Deleted Successfully"
  //         });
  //     }
  // });

  const body = req.body;
  let query = `DELETE FROM all_tour_category WHERE category_id = ?`;
  db_con.query(query, [body.category_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});
router.post("/deleteTourAttributes", (req, res) => {
  const body = req.body;
  let query = `DELETE FROM all_tour_attributes WHERE attributes_id = ?`;
  db_con.query(query, [body.attributes_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});

// tour cms data
router.get("/getAllTourCmsData", (req, res) => {
  query = "SELECT * FROM tour_cms ";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

router.post("/singleCmsTourDetails", (req, res) => {
  const body = req.body;

  query = "SELECT * FROM tour_cms WHERE tour_id=?";
  db_con.query(query, [body.tour_id], function (error, results, fields) {
    if (error) {
      console.log(error);
      res.send({
        code: 402,
        failed: "error request",
      });
    } else {
      if (results.length != 0) {
        res.send({
          code: 200,
          message: "Single Tour Details",
          Payload: results,
        });
      } else {
        res.send({
          code: 404,
          message: "No Data Found",
        });
      }
    }
  });
});

getTourFromTourCms = (id) => {
  TourCMS.showTour({
    tourId: id,
    callback: function (response) {
      return response.tour;
    },
  });
};

//set tour cms data
router.get("/setAllTourCmsData", (req, res) => {
  TourCMS.listTours({
    channelId: 3930,
    callback: function (response) {
      // console.log(response);
      let tableHeader = [];
      tableHeader.push(`tour_id`, `tour_data`);
      let query = "INSERT INTO tour_cms (" + tableHeader + ") VALUES ?";
      let tour_data_container = [];
      response.tour.forEach((element) => {
        TourCMS.showTour({
          tourId: element.tour_id,
          callback: function (response) {
            tour_data_container.push(response.tour);
          },
        });
      });
      setTimeout(() => {
        let values = tour_data_container.reduce((o, a) => {
          let ini = [];

          ini.push(a.tour_id);
          ini.push(JSON.stringify(a));
          o.push(ini);
          return o;
        }, []);
        let delete_query = `DELETE FROM tour_cms;`;
        db_con.query(delete_query, (error, results, fields) => {
          if (error) {
            res.send({
              code: 400,
              failed: "error request",
            });
          } else {
            console.log("Resultats: ", results);
            db_con.query(query, [values], (error, results, fields) => {
              if (error) {
                console.log(error);
                res.send({
                  code: 400,
                  failed: "error request",
                });
              } else {
                console.log("Tour CMS Added Successfully");
                res.send({
                  code: 200,
                  message: "Tour CMS Added Successfully",
                });
              }
            });
          }
        });
      }, 3000);
    },
  });
});

router.post("/deleteTourCms", (req, res) => {
  const body = req.body;
  console.log(body);
  let query = "DELETE FROM tour_cms WHERE tour_id = ?;";
  db_con.query(query, [body.tour_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});

module.exports = router;
