const express = require("express");
const router = express.Router();
const multer = require("multer");
const db_con = require("../connection");

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "uploads/");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + file.originalname);
  },
});

let upload = multer({
  storage: storage,
});

router.get("/", (req, res, next) => {
  res.send("Hellow world");
  console.log("Tour Added");
});

router.post("/addSingleBlogNews", (req, res) => {
  const newsBody = req.body.postObject;
  let container = [];
  let tableHeader = [];
  container.push(newsBody);
  console.log(newsBody);
  tableHeader.push(
    `post_id`,
    `post_image`,
    `post_title`,
    `post_creat_time`,
    `post_category`,
    `post_status`,
    `post_comments`,
    `post_shost_content`,
    `post_main_content`,
    `post_tags`,
    `post_auther`,
    `agent_id`,
    `user_type`,
    `tour_agent_name`,
    `agent_color`
  );
  // let tableHeader = req.body.tableHeader.join(',')
  let query = "INSERT INTO blog_news (" + tableHeader + ") VALUES ?";
  let values = container.reduce((o, a) => {
    let ini = [];
    ini.push(a.post_id);
    ini.push(a.post_image);
    ini.push(a.post_title);
    ini.push(a.post_creat_time);
    ini.push(a.post_category);
    ini.push(a.post_status);
    ini.push(a.post_comments);
    ini.push(a.post_shost_content);
    ini.push(a.post_main_content);
    ini.push(a.post_tags);
    ini.push(a.post_auther);
    ini.push(a.agent_id);
    ini.push(a.user_type);
    ini.push(a.tour_agent_name);
    ini.push(a.agent_color);
    o.push(ini);
    return o;
  }, []);

  db_con.query(query, [values], (error, results, fields) => {
    if (error) {
      console.log(error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Blog Added Successfully",
      });
    }
  });
});

router.post("/editSingleBlog", (req, res) => {
  const newsBody = req.body.postObject;
  let query = `UPDATE blog_news SET ? WHERE post_id= ?`;
  db_con.query(
    query,
    [newsBody, req.body.post_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/setCategory", (req, res) => {
  const categoryBody = req.body;
  let query =
    "INSERT INTO post_category (`category_name`,`category_created_date`,`category_id`) VALUES (?,?,?)";

  db_con.query(
    query,
    [
      categoryBody.category_name,
      categoryBody.category_created_date,
      categoryBody.category_id,
    ],
    (error, results, fields) => {
      if (error) {
        console.log(error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        console.log("Category Added Successfully");
        res.send({
          code: 200,
          message: "Category Added Successfully",
        });
      }
    }
  );
});

const id = (length) => {
  let mask = "";
  mask += "0123456789";
  let result = "";
  for (var i = length; i > 0; --i)
    result += mask[Math.round(Math.random() * (mask.length - 1))];
  return result;
};

// get api

router.get("/getAllPostByVendor", (req, res) => {
  const vendortype = req.query.vendortype;
  const vendorId = req.query.vendorId;
  if (vendortype == "Admin") {
    query = "SELECT * FROM blog_news ORDER BY post_creat_time DESC";

    //  SELECT * FROM blog_news ORDER BY post_creat_time DESC;

    db_con.query(query, function (error, results, fields) {
      if (error) {
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Success",
          Payload: results,
        });
      }
    });
  } else {
    query =
      "SELECT * FROM blog_news WHERE user_type=? AND agent_id=? ORDER BY post_creat_time DESC";
    db_con.query(
      query,
      [vendortype, vendorId],
      function (error, results, fields) {
        if (error) {
          console.log(error);
          res.send({
            code: 402,
            failed: "error request",
          });
        } else {
          if (results.length != 0) {
            res.send({
              code: 200,
              message: "Login Successful",
              Payload: results,
            });
          } else {
            res.send({
              code: 402,
              message: "No Data Found",
            });
          }
        }
      }
    );
  }
});

router.get("/getAllPost", (req, res) => {
  query = " SELECT * FROM blog_news ORDER BY post_creat_time DESC;";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

router.get("/getSinglePost", (req, res) => {
  const postId = req.query.postId;

  query = "SELECT * FROM blog_news WHERE post_id=? ";
  db_con.query(query, [postId], function (error, results, fields) {
    if (error) {
      console.log(error);
      res.send({
        code: 402,
        failed: "error request",
      });
    } else {
      if (results.length != 0) {
        res.send({
          code: 200,
          message: "One Post Successful",
          Payload: results,
        });
      } else {
        res.send({
          code: 402,
          message: "No Data Found",
        });
      }
    }
  });
});

router.get("/getAllCategory", (req, res) => {
  query = "SELECT * FROM post_category ORDER BY category_created_date DESC";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});
router.get("/getAllResentPost", (req, res) => {
  query = "SELECT * FROM blog_news order by post_id desc limit 10;";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

// delete api

router.post("/deleteBlogNews", (req, res) => {
  const body = req.body;
  console.log(body);
  let query = `DELETE FROM blog_news WHERE post_id = ?`;
  db_con.query(query, [body.post_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "News Deleted Successfully",
      });
    }
  });
});

// post_category(`category_name`, `category_created_date`, `category_id`)

router.post("/updateBlogCategory", (req, res) => {
  const body = req.body;
  let query = `UPDATE post_category SET ? WHERE category_id= ?`;

  console.log(body);
  db_con.query(
    query,
    [req.body, req.body.category_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/deleteCategory", (req, res) => {
  // const body = req.body
  // // let query = `DELETE FROM all_tour_category WHERE category_id = ?`;
  // category_id_container = []
  // console.log(req.body)
  // req.body.forEach(element => {
  //     category_id_container.push(element.category_id)
  // });
  // let allids = category_id_container.join(',')
  // let query = `DELETE FROM post_category WHERE category_id IN (` + allids + `);`;
  // db_con.query(query, (error, results, fields) => {
  //     if (error) {
  //         console.log("error ocurred", error);
  //         res.send({
  //             "code": 400,
  //             "failed": "error request"
  //         })
  //     } else {
  //         console.log('Resultats: ', results);
  //         res.send({
  //             "code": 200,
  //             "message": "Deleted Successfully"
  //         });
  //     }
  // });
  const body = req.body;
  let query = `DELETE FROM post_category WHERE category_id = ?`;
  db_con.query(query, [body.category_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});

module.exports = router;
