const express = require("express");
const router = express.Router();
const multer = require("multer");
const db_con = require("../connection");

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "uploads/");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + file.originalname);
  },
});

let upload = multer({
  storage: storage,
});

router.get("/", (req, res, next) => {
  res.send("Hellow world");
  console.log("Tour Added");
});

router.post("/addNewUser", (req, res) => {
  const userBody = req.body;
  getquery = "SELECT * FROM all_user WHERE user_email = ?";
  db_con.query(
    getquery,
    [userBody.user_email],
    function (error, results, fields) {
      if (error) {
        console.log(error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else if (!results.length) {
        console.log(results);

        let query =
          "INSERT INTO all_user (`user_name`,`user_email`,`user_password`,`user_phone`) VALUES (?,?,?,?)";

        db_con.query(
          query,
          [
            userBody.user_name,
            userBody.user_email,
            userBody.user_password,
            userBody.user_phone,
          ],
          (error, results, fields) => {
            if (error) {
              console.log(error);
              res.send({
                code: 400,
                failed: "error request",
              });
            } else {
              console.log("User Added Successfully");
              res.send({
                code: 200,
                message: "User Added Successfully",
              });
            }
          }
        );
      } else {
        res.send({
          code: 402,
          message: "User Already Exist",
        });
      }
    }
  );
});

router.post("/updateNewUser", (req, res) => {
  let query = `UPDATE all_user SET user_phone = ? WHERE user_email = ?; `;

  const userBody = req.body;
  db_con.query(
    query,
    [userBody.user_phone, userBody.user_email],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/userLogin", (req, res) => {
  const body = req.body;

  let query = "SELECT * FROM all_user WHERE user_email=? AND user_password=?";
  db_con.query(
    query,
    [body.user_email, body.user_password],
    function (error, results, fields) {
      if (error) {
        console.log(error);
        res.send({
          code: 402,
          failed: "error request",
        });
      } else {
        if (results.length != 0) {
          res.send({
            code: 200,
            message: "Login Successful",
            Payload: results,
          });
        } else {
          res.send({
            code: 402,
            message: "No Data Found",
          });
        }
      }
    }
  );
});

router.post("/updateCart", (req, res) => {
  const cartData = req.body.cartData;
  let query =
    `UPDATE all_user SET user_cart=` +
    JSON.stringify(cartData) +
    `WHERE user_email=? `;
  console.log(req.body.user_email);
  db_con.query(query, [req.body.user_email], function (error, results, fields) {
    if (error) {
      console.log(error);
      res.send({
        code: 402,
        failed: "error request",
      });
    } else {
      if (results.length != 0) {
        res.send({
          code: 200,
          message: "Update Cart Successful",
          Payload: results,
        });
      } else {
        res.send({
          code: 402,
          message: "No Data Found",
        });
      }
    }
  });
});

//

router.post("/addNewSubscriber", (req, res) => {
  const userBody = req.body;
  let query =
    "INSERT INTO all_subscriber (`id`,`user_name`,`user_email`,`user_phone`,`user_msg`,`subs_type`) VALUES (?,?,?,?,?,?)";

  db_con.query(
    query,
    [
      userBody.id,
      userBody.user_name,
      userBody.user_email,
      userBody.user_phone,
      userBody.user_msg,
      userBody.subs_type,
    ],
    (error, results, fields) => {
      if (error) {
        console.log(error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        console.log("User Added Successfully");
        res.send({
          code: 200,
          message: "User Added Successfully",
        });
      }
    }
  );
});

// get testimonial
router.get("/getAllSubscriber", (req, res) => {
  query = "SELECT * FROM all_subscriber";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

const id = (length) => {
  let mask = "";
  mask += "0123456789";
  let result = "";
  for (var i = length; i > 0; --i)
    result += mask[Math.round(Math.random() * (mask.length - 1))];
  return result;
};

module.exports = router;
